/* A lexical scanner generated by flex */

/* scanner skeleton */

/* modified by Jim Kowalkowski to have everything declared static */

#define FLEX_SCANNER

#include <stdio.h>
#include <stdlib.h>

/* amount of stuff to slurp up with each read */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* returned upon end-of-file */
#define YY_END_TOK 0

/* copy whatever the last rule matched to the standard output */

/* cast to (char *) is because for 8-bit chars, yytext is (unsigned char *) */
/* this used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite()
 */
#define ECHO (void) fwrite( (char *) yytext, yyleng, 1, yyout )

/* gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#define YY_INPUT(buf,result,max_size) \
        if ( (result = read( fileno(yyin), (char *) buf, max_size )) < 0 ) \
            YY_FATAL_ERROR( "read() in flex scanner failed" );
#define YY_NULL 0

/* no semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */

/* #define yyterminate() return ( YY_NULL )  replaced by jbk */
static int yyterminate_internal( void );
#define yyterminate() return yyterminate_internal()

/* report a fatal error */

/* The funky do-while is used to turn this macro definition into
 * a single C statement (which needs a semi-colon terminator).
 * This avoids problems with code like:
 *
 *      if ( something_happens )
 *              YY_FATAL_ERROR( "oops, the something happened" );
 *      else
 *              everything_okay();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the YY_FATAL_ERROR() call.
 */

#define YY_FATAL_ERROR(msg) \
        do \
                { \
                (void) fputs( msg, stderr ); \
                (void) putc( '\n', stderr ); \
                exit( 1 ); \
                } \
        while ( 0 )

/* default yywrap function - always treat EOF as an EOF */
#define yywrap() 1

/* enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN
 */
#define BEGIN yy_start = 1 + 2 *

/* action number for EOF rule of a given start state */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* special action meaning "start processing a new file" */
#define YY_NEW_FILE \
        do \
                { \
                yy_init_buffer( yy_current_buffer, yyin ); \
                yy_load_buffer_state(); \
                } \
        while ( 0 )

/* default declaration of generated scanner - a define so the user can
 * easily add parameters - jbk added the static to YY_DECL
 */
#define YY_DECL static int yylex ( void )

/* code executed at the end of each rule */
#define YY_BREAK break;

#define YY_END_OF_BUFFER_CHAR 0

#ifndef YY_BUF_SIZE
#define YY_BUF_SIZE (YY_READ_BUF_SIZE * 2) /* size of default input buffer */
#endif

typedef struct yy_buffer_state *YY_BUFFER_STATE;

#define YY_CHAR unsigned char
# line 1 "../dbStatic/dbLex.l"
#define INITIAL 0
/*************************************************************************\
* Copyright (c) 2016 UChicago Argonne LLC, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* SPDX-License-Identifier: EPICS
* EPICS BASE is distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution.
\*************************************************************************/
# line 34 "../dbStatic/dbLex.l"
#undef YY_INPUT
#define YY_INPUT(b,r,ms) (r=(*db_yyinput)((char *)b,ms))

static int yyreset(void)
{
    BEGIN INITIAL;
    return(0);
}

#define JSON 1
# line 47 "../dbStatic/dbLex.l"

/* done after the current pattern has been matched and before the
 * corresponding action - sets up yytext
 */
#define YY_DO_BEFORE_ACTION \
        yytext = yy_bp; \
	yyleng = yy_cp - yy_bp; \
        yy_hold_char = *yy_cp; \
        *yy_cp = '\0'; \
        yy_c_buf_p = yy_cp;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* return all but the first 'n' matched characters back to the input stream */
#define yyless(n) \
        do \
                { \
                /* undo effects of setting up yytext */ \
                *yy_cp = yy_hold_char; \
                yy_c_buf_p = yy_cp = yy_bp + n; \
                YY_DO_BEFORE_ACTION; /* set up yytext again */ \
                } \
        while ( 0 )

#define unput(c) yyunput( c, yytext )


struct yy_buffer_state
    {
    FILE *yy_input_file;

    YY_CHAR *yy_ch_buf;         /* input buffer */
    YY_CHAR *yy_buf_pos;        /* current position in input buffer */

    /* size of input buffer in bytes, not including room for EOB characters */
    int yy_buf_size;

    /* number of characters read into yy_ch_buf, not including EOB characters */
    int yy_n_chars;

    int yy_eof_status;          /* whether we've seen an EOF on this buffer */
#define EOF_NOT_SEEN 0
    /* "pending" happens when the EOF has been seen but there's still
     * some text process
     */
#define EOF_PENDING 1
#define EOF_DONE 2
    };

static YY_BUFFER_STATE yy_current_buffer;

/* we provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state"
 */
#define YY_CURRENT_BUFFER yy_current_buffer


/* yy_hold_char holds the character lost when yytext is formed */
static YY_CHAR yy_hold_char;

static int yy_n_chars;          /* number of characters read into yy_ch_buf */



#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

#ifndef YY_USER_INIT
#define YY_USER_INIT
#endif

/* jbk update
extern YY_CHAR *yytext;
extern int yyleng;
extern FILE *yyin, *yyout;
*/

static YY_CHAR *yytext; /* jbk added static */
static int yyleng; /* jbk added static */

static FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0; /* jbk added static */

#define YY_END_OF_BUFFER 39
typedef int yy_state_type;
static const short int yy_accept[164] =
    {   0,
        0,    0,    0,    0,   39,   37,   36,   36,   37,   35,
       21,   24,   25,   19,   26,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   22,   23,   37,
       34,   31,   34,   33,   33,   34,   34,   34,    0,   27,
       20,    0,   35,   21,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
        0,   32,    0,   34,   33,   33,   34,   34,   33,   34,
       34,   34,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,    0,
       33,   34,   33,   34,   34,   34,   19,   19,   19,   19,

       19,   19,   19,   19,   19,   19,   15,   10,    4,    2,
       19,   19,   19,    0,   34,   28,   29,   19,   14,   19,
       19,   19,   19,    7,   19,   19,   19,   19,   19,   19,
        0,   30,   19,   19,    5,    8,    9,   19,   19,   19,
       12,   19,   19,    0,    3,   19,   19,   13,    1,   19,
       19,   19,   19,   17,   19,   19,   18,   19,   19,   16,
       11,    6,    0
    } ;

static const YY_CHAR yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    2,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    5,    6,    7,    5,    8,    5,    5,    9,
       10,    5,   11,   12,   13,   14,   15,   16,   17,   17,
       17,   17,   17,   17,   17,   17,   17,   18,   19,   19,
        5,   19,    5,    5,   20,   20,   20,   20,   21,   20,
       22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
       22,   22,   22,   22,   22,   22,   22,   22,   22,   22,
       18,   23,   18,    5,   22,    5,   24,   25,   26,   27,

       28,   29,   30,   31,   32,   22,   33,   34,   35,   36,
       37,   38,   22,   39,   40,   41,   42,   43,   22,   22,
       44,   22,   45,    5,   46,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,

        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5
    } ;

static const YY_CHAR yy_meta[47] =
    {   0,
        1,    1,    2,    3,    3,    4,    3,    3,    3,    3,
        5,    3,    5,    5,    4,    6,    6,    7,    7,    6,
        6,    5,    4,    6,    8,    6,    6,    6,    8,    5,
        5,    5,    5,    5,    5,    9,    5,    5,    9,    5,
        9,    9,    5,    5,    3,    3
    } ;

static const short int yy_base[175] =
    {   0,
        0,    0,   46,    0,  295,  296,  296,  296,   90,    0,
        0,  296,  296,    0,  296,   67,  255,  262,   67,   65,
      253,  255,  258,  261,  264,  259,  262,  296,  296,   92,
        0,  296,   83,   88,  103,  261,  242,  244,  102,  296,
      296,  279,    0,    0,    0,  254,  248,  251,  241,  234,
      244,  247,  238,  245,   85,  236,  235,  229,   92,  230,
       98,  296,  226,    0,  109,  112,  118,  125,  129,  233,
      232,  223,  226,  239,  238,  229,  228,  216,  224,  231,
      230,  221,  217,  220,  210,  220,  213,  217,  216,    0,
      131,  137,  139,  207,  212,  217,  220,  203,  209,  215,

      214,  211,  211,  196,  199,  193,    0,    0,    0,    0,
      195,  193,  208,    0,  203,    0,    0,  189,    0,  188,
      200,  199,  187,    0,  193,  185,  196,  195,  179,  192,
        0,    0,  183,  187,    0,    0,    0,  170,  179,  177,
      160,  140,  136,    0,    0,  133,  115,    0,    0,  105,
      120,  111,   98,    0,   89,   73,    0,   82,   75,    0,
        0,    0,  296,  159,  168,  177,  182,  189,  194,  200,
      204,  207,  210,  213
    } ;

static const short int yy_def[175] =
    {   0,
      163,    1,  163,    3,  163,  163,  163,  163,  164,  165,
      166,  163,  163,  167,  163,  167,  167,  167,  167,  167,
      167,  167,  167,  167,  167,  167,  167,  163,  163,  168,
      169,  163,  169,  169,  169,  169,  169,  169,  164,  163,
      163,  164,  165,  166,  167,  167,  167,  167,  167,  167,
      167,  167,  167,  167,  167,  167,  167,  167,  167,  167,
      168,  163,  170,  169,  169,  169,  169,  169,  169,  169,
      169,  169,  167,  167,  167,  167,  167,  167,  167,  167,
      167,  167,  167,  167,  167,  167,  167,  167,  167,  171,
      169,  169,  169,  169,  169,  169,  167,  167,  167,  167,

      167,  167,  167,  167,  167,  167,  167,  167,  167,  167,
      167,  167,  167,  172,  169,  169,  169,  167,  167,  167,
      167,  167,  167,  167,  167,  167,  167,  167,  167,  167,
      173,  169,  167,  167,  167,  167,  167,  167,  167,  167,
      167,  167,  167,  174,  167,  167,  167,  167,  167,  167,
      167,  167,  167,  167,  167,  167,  167,  167,  167,  167,
      167,  167,    0,  163,  163,  163,  163,  163,  163,  163,
      163,  163,  163,  163
    } ;

static const short int yy_nxt[343] =
    {   0,
        6,    7,    8,    7,    6,    9,   10,   11,   12,   13,
       14,   15,   14,   14,    6,   14,   14,   14,   14,   14,
       14,   14,    6,   16,   17,   18,   19,   14,   20,   21,
       14,   22,   14,   23,   24,   14,   14,   25,   26,   14,
       14,   14,   27,   14,   28,   29,    6,    7,    8,    7,
        6,   30,   10,    6,    6,    6,   31,   32,   33,   31,
        6,   34,   35,   32,    6,   31,   31,   31,    6,   31,
       31,   31,   31,   31,   36,   31,   31,   31,   31,   31,
       31,   37,   31,   31,   31,   31,   38,   31,   31,   31,
       32,   32,   40,   46,   50,   41,   52,   62,   65,   66,

       47,   67,  162,   62,   40,   51,   53,   41,   68,  161,
       82,  160,   42,   83,   63,   68,   67,   87,   69,   69,
       63,   88,   67,   68,   42,   67,  159,   69,   69,   68,
       68,  158,   68,   91,   91,   92,   68,   92,  157,   68,
       93,   93,   67,  156,   69,   69,   91,   91,  155,   68,
      154,   68,   93,   93,   93,   93,   68,  153,   68,   39,
       39,   39,   39,   39,   39,   39,   39,   39,   43,  152,
       43,   43,   43,   43,   43,   43,   43,   44,  151,   44,
       44,   44,   44,   44,   44,   44,   45,   45,   45,   45,
       45,   61,   61,   61,   61,   61,   61,   61,   64,   64,

      150,   64,   64,   61,  149,  148,  147,   61,   61,  114,
      146,  114,  131,  145,  131,  144,  143,  144,   61,  142,
       61,  141,  140,  139,  138,  137,  136,  135,  134,  133,
      132,  130,  129,  128,  127,  126,  125,  124,  123,  122,
      121,  120,  119,  118,  117,  116,  115,  113,  112,  111,
      110,  109,  108,  107,  106,  105,  104,  103,  102,  101,
      100,   99,   98,   97,   96,   95,   94,   90,   89,   86,
       85,   84,   81,   80,   79,   78,   77,   76,   75,   74,
       73,  163,   72,   71,   70,   60,   59,   58,   57,   56,
       55,   54,   49,   48,  163,    5,  163,  163,  163,  163,

      163,  163,  163,  163,  163,  163,  163,  163,  163,  163,
      163,  163,  163,  163,  163,  163,  163,  163,  163,  163,
      163,  163,  163,  163,  163,  163,  163,  163,  163,  163,
      163,  163,  163,  163,  163,  163,  163,  163,  163,  163,
      163,  163
    } ;

static const short int yy_chk[343] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    9,   16,   19,    9,   20,   30,   33,   33,

       16,   34,  159,   61,   39,   19,   20,   39,   34,  158,
       55,  156,    9,   55,   30,   34,   35,   59,   35,   35,
       61,   59,   65,   35,   39,   66,  155,   66,   66,   65,
       35,  153,   66,   67,   67,   68,   65,   68,  152,   66,
       68,   68,   69,  151,   69,   69,   91,   91,  150,   69,
      147,   91,   92,   92,   93,   93,   69,  146,   91,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  165,  143,
      165,  165,  165,  165,  165,  165,  165,  166,  142,  166,
      166,  166,  166,  166,  166,  166,  167,  167,  167,  167,
      167,  168,  168,  168,  168,  168,  168,  168,  169,  169,

      141,  169,  169,  170,  140,  139,  138,  170,  170,  171,
      134,  171,  172,  133,  172,  173,  130,  173,  174,  129,
      174,  128,  127,  126,  125,  123,  122,  121,  120,  118,
      115,  113,  112,  111,  106,  105,  104,  103,  102,  101,
      100,   99,   98,   97,   96,   95,   94,   89,   88,   87,
       86,   85,   84,   83,   82,   81,   80,   79,   78,   77,
       76,   75,   74,   73,   72,   71,   70,   63,   60,   58,
       57,   56,   54,   53,   52,   51,   50,   49,   48,   47,
       46,   42,   38,   37,   36,   27,   26,   25,   24,   23,
       22,   21,   18,   17,    5,  163,  163,  163,  163,  163,

      163,  163,  163,  163,  163,  163,  163,  163,  163,  163,
      163,  163,  163,  163,  163,  163,  163,  163,  163,  163,
      163,  163,  163,  163,  163,  163,  163,  163,  163,  163,
      163,  163,  163,  163,  163,  163,  163,  163,  163,  163,
      163,  163
    } ;

static yy_state_type yy_last_accepting_state;
static YY_CHAR *yy_last_accepting_cpos;

/* the intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0

/* these variables are all declared out here so that section 3 code can
 * manipulate them
 */
/* points to current character in buffer */
static YY_CHAR *yy_c_buf_p = (YY_CHAR *) 0;
static int yy_init = 1;         /* whether we need to initialize */
static int yy_start = 0;        /* start state number */

/* flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

static yy_state_type yy_get_previous_state ( void );
static yy_state_type yy_try_NUL_trans ( yy_state_type current_state );
static int yy_get_next_buffer ( void );
static void yyunput ( YY_CHAR c, YY_CHAR *buf_ptr );

/* jbk added static in front all these */
static void yyrestart ( FILE *input_file );
static void yy_switch_to_buffer ( YY_BUFFER_STATE new_buffer );
static void yy_load_buffer_state ( void );
static YY_BUFFER_STATE yy_create_buffer ( FILE *file, int size );
static void yy_delete_buffer ( YY_BUFFER_STATE b );
static void yy_init_buffer ( YY_BUFFER_STATE b, FILE *file );

#define yy_new_buffer yy_create_buffer

#ifdef yyneed_input
#ifdef __cplusplus
static int yyinput ( void );
#else
static int input ( void );
#endif
#endif

YY_DECL
    {
    register yy_state_type yy_current_state;
    register YY_CHAR *yy_cp, *yy_bp;
    register int yy_act;




    if ( yy_init )
        {
        YY_USER_INIT;

        if ( ! yy_start )
            yy_start = 1;       /* first start state */

        if ( ! yyin )
            yyin = stdin;

        if ( ! yyout )
            yyout = stdout;

        if ( yy_current_buffer )
            yy_init_buffer( yy_current_buffer, yyin );
        else
            yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE );

        yy_load_buffer_state();

        yy_init = 0;
        }

    while ( 1 )         /* loops until end-of-file is reached */
        {
        yy_cp = yy_c_buf_p;

        /* support of yytext */
        *yy_cp = yy_hold_char;

        /* yy_bp points to the position in yy_ch_buf of the start of the
         * current run.
         */
        yy_bp = yy_cp;

	yy_current_state = yy_start;
yy_match:
	do
	    {
	    YY_CHAR yy_c = yy_ec[(int)*yy_cp];
	    if ( yy_accept[yy_current_state] )
		{
		yy_last_accepting_state = yy_current_state;
		yy_last_accepting_cpos = yy_cp;
		}
	    while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = yy_def[yy_current_state];
		if ( yy_current_state >= 164 )
		    yy_c = yy_meta[(int)yy_c];
		}
	    yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
	    ++yy_cp;
	    }
	while ( yy_base[yy_current_state] != 296 );

yy_find_action:
	yy_act = yy_accept[yy_current_state];

        YY_DO_BEFORE_ACTION;
        YY_USER_ACTION;

do_action:      /* this label is used only to access EOF actions */


        switch ( yy_act )
            {
	    case 0: /* must backtrack */
	    /* undo the effects of YY_DO_BEFORE_ACTION */
	    *yy_cp = yy_hold_char;
	    yy_cp = yy_last_accepting_cpos;
	    yy_current_state = yy_last_accepting_state;
	    goto yy_find_action;

case 1:
# line 49 "../dbStatic/dbLex.l"
return(tokenINCLUDE);
	YY_BREAK
case 2:
# line 50 "../dbStatic/dbLex.l"
return(tokenPATH);
	YY_BREAK
case 3:
# line 51 "../dbStatic/dbLex.l"
return(tokenADDPATH);
	YY_BREAK
case 4:
# line 52 "../dbStatic/dbLex.l"
return(tokenMENU);
	YY_BREAK
case 5:
# line 53 "../dbStatic/dbLex.l"
return(tokenCHOICE);
	YY_BREAK
case 6:
# line 54 "../dbStatic/dbLex.l"
return(tokenRECORDTYPE);
	YY_BREAK
case 7:
# line 55 "../dbStatic/dbLex.l"
return(tokenFIELD);
	YY_BREAK
case 8:
# line 56 "../dbStatic/dbLex.l"
return(tokenDEVICE);
	YY_BREAK
case 9:
# line 57 "../dbStatic/dbLex.l"
return(tokenDRIVER);
	YY_BREAK
case 10:
# line 58 "../dbStatic/dbLex.l"
return(tokenLINK);
	YY_BREAK
case 11:
# line 59 "../dbStatic/dbLex.l"
return(tokenBREAKTABLE);
	YY_BREAK
case 12:
# line 60 "../dbStatic/dbLex.l"
return(tokenRECORD);
	YY_BREAK
case 13:
# line 61 "../dbStatic/dbLex.l"
return(tokenGRECORD);
	YY_BREAK
case 14:
# line 62 "../dbStatic/dbLex.l"
return(tokenALIAS);
	YY_BREAK
case 15:
# line 63 "../dbStatic/dbLex.l"
return(tokenINFO);
	YY_BREAK
case 16:
# line 64 "../dbStatic/dbLex.l"
return(tokenREGISTRAR);
	YY_BREAK
case 17:
# line 65 "../dbStatic/dbLex.l"
return(tokenFUNCTION);
	YY_BREAK
case 18:
# line 66 "../dbStatic/dbLex.l"
return(tokenVARIABLE);
	YY_BREAK
case 19:
# line 68 "../dbStatic/dbLex.l"
{ /* unquoted string or number */
    yylval.Str = dbmfStrdup((char *) yytext);
    return(tokenSTRING);
}
	YY_BREAK
case 20:
# line 73 "../dbStatic/dbLex.l"
{ /* quoted string */
    yylval.Str = dbmfStrdup((char *) yytext+1);
    yylval.Str[strlen(yylval.Str)-1] = '\0';
    return(tokenSTRING);
}
	YY_BREAK
case 21:
# line 79 "../dbStatic/dbLex.l"
{ /*C definition in recordtype*/
    yylval.Str = dbmfStrdup((char *) yytext+1);
    return(tokenCDEFS);
}
	YY_BREAK
case 22:
# line 84 "../dbStatic/dbLex.l"
return(yytext[0]);
	YY_BREAK
case 23:
# line 85 "../dbStatic/dbLex.l"
return(yytext[0]);
	YY_BREAK
case 24:
# line 86 "../dbStatic/dbLex.l"
return(yytext[0]);
	YY_BREAK
case 25:
# line 87 "../dbStatic/dbLex.l"
return(yytext[0]);
	YY_BREAK
case 26:
# line 88 "../dbStatic/dbLex.l"
return(yytext[0]);
	YY_BREAK
case 27:
# line 90 "../dbStatic/dbLex.l"
{ /* bad string */
    yyerrorAbort("Newline in string, closing quote missing");
}
	YY_BREAK
case 28:
# line 94 "../dbStatic/dbLex.l"
return jsonNULL;
	YY_BREAK
case 29:
# line 95 "../dbStatic/dbLex.l"
return jsonTRUE;
	YY_BREAK
case 30:
# line 96 "../dbStatic/dbLex.l"
return jsonFALSE;
	YY_BREAK
case 31:
# line 98 "../dbStatic/dbLex.l"
return yytext[0];
	YY_BREAK
case 32:
# line 100 "../dbStatic/dbLex.l"
{
    yylval.Str = dbmfStrdup((char *) yytext);
    return jsonSTRING;
}
	YY_BREAK
case 33:
# line 105 "../dbStatic/dbLex.l"
{
    yylval.Str = dbmfStrdup((char *) yytext);
    return jsonNUMBER;
}
	YY_BREAK
case 34:
# line 110 "../dbStatic/dbLex.l"
{
    yylval.Str = dbmfStrdup((char *) yytext);
    return jsonBARE;
}
	YY_BREAK
case 35:
# line 115 "../dbStatic/dbLex.l"
;
	YY_BREAK
case 36:
# line 117 "../dbStatic/dbLex.l"
;
	YY_BREAK
case 37:
# line 119 "../dbStatic/dbLex.l"
{
    char message[40];
    YY_BUFFER_STATE *dummy=0;

    if (isprint((int) yytext[0])) {
        sprintf(message, "Invalid character '%c'", yytext[0]);
    }
    else {
        sprintf(message, "Invalid character 0x%2.2x", yytext[0]);
    }
    yyerrorAbort(message);
    /*The following suppresses compiler warning messages*/
    if(FALSE) yyunput('c',(unsigned char *) message);
    if(FALSE) yy_switch_to_buffer(*dummy);
}
	YY_BREAK
case 38:
# line 135 "../dbStatic/dbLex.l"
ECHO;
	YY_BREAK
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(JSON):
    yyterminate();

            case YY_END_OF_BUFFER:
                {
                /* amount of text matched not including the EOB char */
                int yy_amount_of_matched_text = yy_cp - yytext - 1;

                /* undo the effects of YY_DO_BEFORE_ACTION */
                *yy_cp = yy_hold_char;

                /* note that here we test for yy_c_buf_p "<=" to the position
                 * of the first EOB in the buffer, since yy_c_buf_p will
                 * already have been incremented past the NUL character
                 * (since all states make transitions on EOB to the end-
                 * of-buffer state).  Contrast this with the test in yyinput().
                 */
                if ( yy_c_buf_p <= &yy_current_buffer->yy_ch_buf[yy_n_chars] )
                    /* this was really a NUL */
                    {
                    yy_state_type yy_next_state;

                    yy_c_buf_p = yytext + yy_amount_of_matched_text;

                    yy_current_state = yy_get_previous_state();

                    /* okay, we're now positioned to make the
                     * NUL transition.  We couldn't have
                     * yy_get_previous_state() go ahead and do it
                     * for us because it doesn't know how to deal
                     * with the possibility of jamming (and we
                     * don't want to build jamming into it because
                     * then it will run more slowly)
                     */

                    yy_next_state = yy_try_NUL_trans( yy_current_state );

                    yy_bp = yytext + YY_MORE_ADJ;

                    if ( yy_next_state )
                        {
                        /* consume the NUL */
                        yy_cp = ++yy_c_buf_p;
                        yy_current_state = yy_next_state;
                        goto yy_match;
                        }

                    else
                        {
                        goto yy_find_action;
                        }
                    }

                else switch ( yy_get_next_buffer() )
                    {
                    case EOB_ACT_END_OF_FILE:
                        {
                        yy_did_buffer_switch_on_eof = 0;

                        if ( yywrap() )
                            {
                            /* note: because we've taken care in
                             * yy_get_next_buffer() to have set up yytext,
                             * we can now set up yy_c_buf_p so that if some
                             * total hoser (like flex itself) wants
                             * to call the scanner after we return the
                             * YY_NULL, it'll still work - another YY_NULL
                             * will get returned.
                             */
                            yy_c_buf_p = yytext + YY_MORE_ADJ;

                            yy_act = YY_STATE_EOF((yy_start - 1) / 2);
                            goto do_action;
                            }

                        else
                            {
                            if ( ! yy_did_buffer_switch_on_eof )
                                YY_NEW_FILE;
                            }
                        }
                        break;

                    case EOB_ACT_CONTINUE_SCAN:
                        yy_c_buf_p = yytext + yy_amount_of_matched_text;

                        yy_current_state = yy_get_previous_state();

                        yy_cp = yy_c_buf_p;
                        yy_bp = yytext + YY_MORE_ADJ;
                        goto yy_match;

                    case EOB_ACT_LAST_MATCH:
                        yy_c_buf_p =
                            &yy_current_buffer->yy_ch_buf[yy_n_chars];

                        yy_current_state = yy_get_previous_state();

                        yy_cp = yy_c_buf_p;
                        yy_bp = yytext + YY_MORE_ADJ;
                        goto yy_find_action;
                    }
                break;
                }

            default:
#ifdef FLEX_DEBUG
                printf( "action # %d\n", yy_act );
#endif
                YY_FATAL_ERROR(
                        "fatal flex scanner internal error--no action found" );
            }
        }
    }


/* yy_get_next_buffer - try to read in a new buffer
 *
 * synopsis
 *     int yy_get_next_buffer();
 *
 * returns a code representing an action
 *     EOB_ACT_LAST_MATCH -
 *     EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *     EOB_ACT_END_OF_FILE - end of file
 */

static int yy_get_next_buffer( void )

    {
    register YY_CHAR *dest = yy_current_buffer->yy_ch_buf;
    register YY_CHAR *source = yytext - 1; /* copy prev. char, too */
    register int number_to_move, i;
    int ret_val;

    if ( yy_c_buf_p > &yy_current_buffer->yy_ch_buf[yy_n_chars + 1] )
        YY_FATAL_ERROR(
                "fatal flex scanner internal error--end of buffer missed" );

    /* try to read more data */

    /* first move last chars to start of buffer */
    number_to_move = yy_c_buf_p - yytext;

    for ( i = 0; i < number_to_move; ++i )
        *(dest++) = *(source++);

    if ( yy_current_buffer->yy_eof_status != EOF_NOT_SEEN )
        /* don't do the read, it's not guaranteed to return an EOF,
         * just force an EOF
         */
        yy_n_chars = 0;

    else
        {
        int num_to_read = yy_current_buffer->yy_buf_size - number_to_move - 1;

        if ( num_to_read > YY_READ_BUF_SIZE )
            num_to_read = YY_READ_BUF_SIZE;

        else if ( num_to_read <= 0 )
            YY_FATAL_ERROR( "fatal error - scanner input buffer overflow" );

        /* read in more data */
        YY_INPUT( (&yy_current_buffer->yy_ch_buf[number_to_move]),
                  yy_n_chars, num_to_read );
        }

    if ( yy_n_chars == 0 )
        {
        if ( number_to_move - YY_MORE_ADJ == 1 )
            {
            ret_val = EOB_ACT_END_OF_FILE;
            yy_current_buffer->yy_eof_status = EOF_DONE;
            }

        else
            {
            ret_val = EOB_ACT_LAST_MATCH;
            yy_current_buffer->yy_eof_status = EOF_PENDING;
            }
        }

    else
        ret_val = EOB_ACT_CONTINUE_SCAN;

    yy_n_chars += number_to_move;
    yy_current_buffer->yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
    yy_current_buffer->yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

    /* yytext begins at the second character in yy_ch_buf; the first
     * character is the one which preceded it before reading in the latest
     * buffer; it needs to be kept around in case it's a newline, so
     * yy_get_previous_state() will have with '^' rules active
     */

    yytext = &yy_current_buffer->yy_ch_buf[1];

    return ( ret_val );
    }


/* yy_get_previous_state - get the state just before the EOB char was reached
 *
 * synopsis
 *     yy_state_type yy_get_previous_state();
 */

static yy_state_type yy_get_previous_state( void )

    {
    register yy_state_type yy_current_state;
    register YY_CHAR *yy_cp;

    yy_current_state = yy_start;

    for ( yy_cp = yytext + YY_MORE_ADJ; yy_cp < yy_c_buf_p; ++yy_cp )
        {
	YY_CHAR yy_c = (*yy_cp ? yy_ec[(int)*yy_cp] : 1);
	if ( yy_accept[yy_current_state] )
	    {
	    yy_last_accepting_state = yy_current_state;
	    yy_last_accepting_cpos = yy_cp;
	    }
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
	    {
	    yy_current_state = yy_def[yy_current_state];
	    if ( yy_current_state >= 164 )
		yy_c = yy_meta[(int)yy_c];
	    }
	yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
        }

    return ( yy_current_state );
    }


/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *     next_state = yy_try_NUL_trans( current_state );
 */

static yy_state_type yy_try_NUL_trans( register yy_state_type yy_current_state )
    {
    register int yy_is_jam;
    YY_CHAR *yy_cp = yy_c_buf_p;

    YY_CHAR yy_c = 1;
    if ( yy_accept[yy_current_state] )
	{
	yy_last_accepting_state = yy_current_state;
	yy_last_accepting_cpos = yy_cp;
	}
    while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
	{
	yy_current_state = yy_def[yy_current_state];
	if ( yy_current_state >= 164 )
	    yy_c = yy_meta[(int)yy_c];
	}
    yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
    yy_is_jam = (yy_base[yy_current_state] == 296);

    return ( yy_is_jam ? 0 : yy_current_state );
    }


static void yyunput( YY_CHAR c, register YY_CHAR *yy_bp )
    {
    register YY_CHAR *yy_cp = yy_c_buf_p;

    /* undo effects of setting up yytext */
    *yy_cp = yy_hold_char;

    if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
        { /* need to shift things up to make room */
        register int number_to_move = yy_n_chars + 2; /* +2 for EOB chars */
        register YY_CHAR *dest =
            &yy_current_buffer->yy_ch_buf[yy_current_buffer->yy_buf_size + 2];
        register YY_CHAR *source =
            &yy_current_buffer->yy_ch_buf[number_to_move];

        while ( source > yy_current_buffer->yy_ch_buf )
            *--dest = *--source;

        yy_cp += dest - source;
        yy_bp += dest - source;
        yy_n_chars = yy_current_buffer->yy_buf_size;

        if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
            YY_FATAL_ERROR( "flex scanner push-back overflow" );
        }

    if ( yy_cp > yy_bp && yy_cp[-1] == '\n' )
        yy_cp[-2] = '\n';

    *--yy_cp = c;

    /* note: the formal parameter *must* be called "yy_bp" for this
     *       macro to now work correctly
     */
    YY_DO_BEFORE_ACTION; /* set up yytext again */
    }


#ifdef yyneed_input
#ifdef __cplusplus
static int yyinput( void )
#else
static int input( void )
#endif

    {
    int c;
    YY_CHAR *yy_cp = yy_c_buf_p;

    *yy_cp = yy_hold_char;

    if ( *yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
        {
        /* yy_c_buf_p now points to the character we want to return.
         * If this occurs *before* the EOB characters, then it's a
         * valid NUL; if not, then we've hit the end of the buffer.
         */
        if ( yy_c_buf_p < &yy_current_buffer->yy_ch_buf[yy_n_chars] )
            /* this was really a NUL */
            *yy_c_buf_p = '\0';

        else
            { /* need more input */
            yytext = yy_c_buf_p;
            ++yy_c_buf_p;

            switch ( yy_get_next_buffer() )
                {
                case EOB_ACT_END_OF_FILE:
                    {
                    if ( yywrap() )
                        {
                        yy_c_buf_p = yytext + YY_MORE_ADJ;
                        return ( EOF );
                        }

                    YY_NEW_FILE;

#ifdef __cplusplus
                    return ( yyinput() );
#else
                    return ( input() );
#endif
                    }
                    break;

                case EOB_ACT_CONTINUE_SCAN:
                    yy_c_buf_p = yytext + YY_MORE_ADJ;
                    break;

                case EOB_ACT_LAST_MATCH:
#ifdef __cplusplus
                    YY_FATAL_ERROR( "unexpected last match in yyinput()" );
#else
                    YY_FATAL_ERROR( "unexpected last match in input()" );
#endif
                }
            }
        }

    c = *yy_c_buf_p;
    yy_hold_char = *++yy_c_buf_p;

    return ( c );
    }
#endif /* yyneed_input */


/* jbk added static in front of func */
static void yyrestart( FILE *input_file )
    {
    if ( yy_current_buffer )
        yy_init_buffer( yy_current_buffer, input_file );
    else
        yy_current_buffer = yy_create_buffer( input_file, YY_BUF_SIZE );

    yy_load_buffer_state();
    }


/* jbk added static in front of func */
static void yy_switch_to_buffer( YY_BUFFER_STATE new_buffer )
    {
    if ( yy_current_buffer == new_buffer )
        return;

    if ( yy_current_buffer )
        {
        /* flush out information for old buffer */
        *yy_c_buf_p = yy_hold_char;
        yy_current_buffer->yy_buf_pos = yy_c_buf_p;
        yy_current_buffer->yy_n_chars = yy_n_chars;
        }

    yy_current_buffer = new_buffer;
    yy_load_buffer_state();

    /* we don't actually know whether we did this switch during
     * EOF (yywrap()) processing, but the only time this flag
     * is looked at is after yywrap() is called, so it's safe
     * to go ahead and always set it.
     */
    yy_did_buffer_switch_on_eof = 1;
    }


/* jbk added static in front of func */
static void yy_load_buffer_state( void )
    {
    yy_n_chars = yy_current_buffer->yy_n_chars;
    yytext = yy_c_buf_p = yy_current_buffer->yy_buf_pos;
    yyin = yy_current_buffer->yy_input_file;
    yy_hold_char = *yy_c_buf_p;
    }


/* jbk added static in front of func */
static YY_BUFFER_STATE yy_create_buffer( FILE *file, int size )
    {
    YY_BUFFER_STATE b;

    b = (YY_BUFFER_STATE) malloc( sizeof( struct yy_buffer_state ) );

    if ( ! b )
        YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

    b->yy_buf_size = size;

    /* yy_ch_buf has to be 2 characters longer than the size given because
     * we need to put in 2 end-of-buffer characters.
     */
    b->yy_ch_buf = (YY_CHAR *) malloc( (unsigned) (b->yy_buf_size + 2) );

    if ( ! b->yy_ch_buf )
        YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

    yy_init_buffer( b, file );

    return ( b );
    }


/* jbk added static in front of func */
static void yy_delete_buffer( YY_BUFFER_STATE b )
    {
    if ( b == yy_current_buffer )
        yy_current_buffer = (YY_BUFFER_STATE) 0;

    free( (char *) b->yy_ch_buf );
    free( (char *) b );
    }


/* jbk added static in front of func */
static void yy_init_buffer( YY_BUFFER_STATE b, FILE *file )
    {
    b->yy_input_file = file;

    /* we put in the '\n' and start reading from [1] so that an
     * initial match-at-newline will be true.
     */

    b->yy_ch_buf[0] = '\n';
    b->yy_n_chars = 1;

    /* we always need two end-of-buffer characters.  The first causes
     * a transition to the end-of-buffer state.  The second causes
     * a jam in that state.
     */
    b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;
    b->yy_ch_buf[2] = YY_END_OF_BUFFER_CHAR;

    b->yy_buf_pos = &b->yy_ch_buf[1];

    b->yy_eof_status = EOF_NOT_SEEN;
    }

static int yyterminate_internal( void )
{
        /* jbk fix - buffer created by yy_create_buffer needs to be freed */
        yy_delete_buffer(yy_current_buffer);
        yy_current_buffer=NULL;
        return YY_NULL;
}

# line 135 "../dbStatic/dbLex.l"

